// **********************************************************************
//
// Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.3
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Changes the security context for the current session.
 * 
 * <p> A security context limits the set of objects which will
 * be returned by all queries and restricts what updates
 * can be made. </p>
 * 
 * <p> Current valid values for security context:
 * <ul>
 * <li>{@link omero.model.ExperimenterGroup} - logs into a
 * specific group</li>
 * <li>{@link omero.model.Share} - uses IShare to activate a
 * share</li>
 * </ul> </p>
 * 
 * <p> Passing an unloaded version of either object type will change
 * the way the current session operates. Note: only objects which
 * are returned by the {@link #getSecurityContexts} method are
 * considered valid. Any other instance will cause an exception to
 * be thrown. </p>
 * 
 * <h4>Example usage in Python:<h4>
 * <pre>
 * sf = client.createSession()
 * objs = sf.getSecurityContexts()
 * old = sf.setSecurityContext(objs\[-1])
 * </pre>
 * 
 **/

public abstract class Callback_ServiceFactory_setSecurityContext
    extends IceInternal.TwowayCallback implements Ice.TwowayCallbackArg1UE<omero.model.IObject>
{
    public final void __completed(Ice.AsyncResult __result)
    {
        ServiceFactoryPrxHelper.__setSecurityContext_completed(this, __result);
    }
}
