// **********************************************************************
//
// Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.3
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Primary callback interface for interaction between client and
 * server session (""ServiceFactory""). Where possible these methods
 * will be called one-way to prevent clients from hanging the server.
 **/
public interface ClientCallbackPrx extends Ice.ObjectPrx
{
    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     **/
    public void requestHeartbeat();

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void requestHeartbeat(java.util.Map<String, String> __ctx);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat();

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(Ice.Callback __cb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(Callback_ClientCallback_requestHeartbeat __cb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx, Callback_ClientCallback_requestHeartbeat __cb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(IceInternal.Functional_VoidCallback __responseCb, 
                                                  IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(IceInternal.Functional_VoidCallback __responseCb, 
                                                  IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                                  IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx, 
                                                  IceInternal.Functional_VoidCallback __responseCb, 
                                                  IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx, 
                                                  IceInternal.Functional_VoidCallback __responseCb, 
                                                  IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                                  IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __result The asynchronous result object.
     **/
    public void end_requestHeartbeat(Ice.AsyncResult __result);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     **/
    public void sessionClosed();

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __ctx The Context map to send with the invocation.
     **/
    public void sessionClosed(java.util.Map<String, String> __ctx);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed();

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(Ice.Callback __cb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(Callback_ClientCallback_sessionClosed __cb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx, Callback_ClientCallback_sessionClosed __cb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(IceInternal.Functional_VoidCallback __responseCb, 
                                               IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(IceInternal.Functional_VoidCallback __responseCb, 
                                               IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                               IceInternal.Functional_BoolCallback __sentCb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx, 
                                               IceInternal.Functional_VoidCallback __responseCb, 
                                               IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx, 
                                               IceInternal.Functional_VoidCallback __responseCb, 
                                               IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                               IceInternal.Functional_BoolCallback __sentCb);

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __result The asynchronous result object.
     **/
    public void end_sessionClosed(Ice.AsyncResult __result);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     **/
    public void shutdownIn(long milliseconds);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void shutdownIn(long milliseconds, java.util.Map<String, String> __ctx);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, java.util.Map<String, String> __ctx);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, Ice.Callback __cb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, Callback_ClientCallback_shutdownIn __cb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, java.util.Map<String, String> __ctx, Callback_ClientCallback_shutdownIn __cb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, 
                                            IceInternal.Functional_VoidCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, 
                                            IceInternal.Functional_VoidCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, 
                                            java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_VoidCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, 
                                            java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_VoidCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __result The asynchronous result object.
     **/
    public void end_shutdownIn(Ice.AsyncResult __result);
}
