// **********************************************************************
//
// Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.3
//
// <auto-generated>
//
// Generated from file `JobHandle.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Allows submission of asynchronous jobs.
 * <p>
 * NOTE: The calling order for the service is as follows:
 * <ol>
 * <li>{@link #submit} <em>or</em> {@link #attach}</li>
 * <li>any of the other methods</li>
 * <li>{@link #close}</li>
 * </ol>
 * </p>
 * Calling {@link #close} does not cancel or otherwise change
 * the Job state. See {@link #cancelJob}.
 **/
public interface JobHandlePrx extends StatefulServiceInterfacePrx
{
    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     *
     * @param job Not null
     **/
    public long submit(omero.model.Job j)
        throws omero.ServerError;

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     *
     * @param job Not null
     * @param __ctx The Context map to send with the invocation.
     **/
    public long submit(omero.model.Job j, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, java.util.Map<String, String> __ctx);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, Ice.Callback __cb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, Callback_JobHandle_submit __cb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, java.util.Map<String, String> __ctx, Callback_JobHandle_submit __cb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, 
                                        IceInternal.Functional_LongCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, 
                                        IceInternal.Functional_LongCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, 
                                        java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_LongCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, 
                                        java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_LongCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __result The asynchronous result object.
     **/
    public long end_submit(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     *
     * @throws ApiUsageException
     * if the {@link Job id} does not exist.
     **/
    public omero.model.JobStatus attach(long jobId)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     *
     * @throws ApiUsageException
     * if the {@link Job id} does not exist.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.JobStatus attach(long jobId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, java.util.Map<String, String> __ctx);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, Ice.Callback __cb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, Callback_JobHandle_attach __cb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, java.util.Map<String, String> __ctx, Callback_JobHandle_attach __cb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, 
                                        IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, 
                                        IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, 
                                        java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_attach(long jobId, 
                                        java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if the {@link Job id} does not exist.
     **/
    public omero.model.JobStatus end_attach(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.Job}
     **/
    public omero.model.Job getJob()
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.Job}
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Job getJob(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.Job}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob();

    /**
     * Returns the current {@link omero.model.Job}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(Ice.Callback __cb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(Callback_JobHandle_getJob __cb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Callback_JobHandle_getJob __cb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(IceInternal.Functional_GenericCallback1<omero.model.Job> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(IceInternal.Functional_GenericCallback1<omero.model.Job> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_GenericCallback1<omero.model.Job> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_GenericCallback1<omero.model.Job> __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current {@link omero.model.Job}
     * @param __result The asynchronous result object.
     **/
    public omero.model.Job end_getJob(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     **/
    public omero.model.JobStatus jobStatus()
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.JobStatus jobStatus(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus();

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(Ice.Callback __cb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(Callback_JobHandle_jobStatus __cb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx, Callback_JobHandle_jobStatus __cb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_GenericCallback1<omero.model.JobStatus> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __result The asynchronous result object.
     **/
    public omero.model.JobStatus end_jobStatus(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     **/
    public omero.RTime jobFinished()
        throws omero.ServerError;

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RTime jobFinished(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished();

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(Ice.Callback __cb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(Callback_JobHandle_jobFinished __cb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx, Callback_JobHandle_jobFinished __cb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(IceInternal.Functional_GenericCallback1<omero.RTime> __responseCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(IceInternal.Functional_GenericCallback1<omero.RTime> __responseCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                             IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx, 
                                             IceInternal.Functional_GenericCallback1<omero.RTime> __responseCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx, 
                                             IceInternal.Functional_GenericCallback1<omero.RTime> __responseCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                             IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                             IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __result The asynchronous result object.
     **/
    public omero.RTime end_jobFinished(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current message for job. May be set during
     * processing.
     **/
    public String jobMessage()
        throws omero.ServerError;

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __ctx The Context map to send with the invocation.
     **/
    public String jobMessage(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage();

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(Ice.Callback __cb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(Callback_JobHandle_jobMessage __cb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx, Callback_JobHandle_jobMessage __cb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __result The asynchronous result object.
     **/
    public String end_jobMessage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     **/
    public boolean jobRunning()
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobRunning(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning();

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(Ice.Callback __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(Callback_JobHandle_jobRunning __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx, Callback_JobHandle_jobRunning __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(IceInternal.Functional_BoolCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(IceInternal.Functional_BoolCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_BoolCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_BoolCallback __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __result The asynchronous result object.
     **/
    public boolean end_jobRunning(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     **/
    public boolean jobError()
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobError(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError();

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(Ice.Callback __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(Callback_JobHandle_jobError __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx, Callback_JobHandle_jobError __cb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                          IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx, 
                                          IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx, 
                                          IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                          IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __result The asynchronous result object.
     **/
    public boolean end_jobError(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     **/
    public void cancelJob()
        throws omero.ServerError;

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void cancelJob(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob();

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(Ice.Callback __cb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(Callback_JobHandle_cancelJob __cb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx, Callback_JobHandle_cancelJob __cb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __result The asynchronous result object.
     **/
    public void end_cancelJob(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     **/
    public String setStatus(String status)
        throws omero.ServerError;

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public String setStatus(String status, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, java.util.Map<String, String> __ctx);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, Ice.Callback __cb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, Callback_JobHandle_setStatus __cb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, java.util.Map<String, String> __ctx, Callback_JobHandle_setStatus __cb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, 
                                           IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, 
                                           IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, 
                                           java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatus(String status, 
                                           java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __result The asynchronous result object.
     **/
    public String end_setStatus(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the job's message string, and returns the previous
     * value.
     *
     * @return the previous message value
     **/
    public String setMessage(String message)
        throws omero.ServerError;

    /**
     * Sets the job's message string, and returns the previous
     * value.
     *
     * @param __ctx The Context map to send with the invocation.
     * @return the previous message value
     **/
    public String setMessage(String message, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, Ice.Callback __cb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, Callback_JobHandle_setMessage __cb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx, Callback_JobHandle_setMessage __cb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, 
                                            IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, 
                                            IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, 
                                            java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, 
                                            java.util.Map<String, String> __ctx, 
                                            IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                            IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                            IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __result The asynchronous result object.
     * @return the previous message value
     **/
    public String end_setMessage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Like {@link #setStatus} but also sets the message.
     **/
    public String setStatusAndMessage(String status, omero.RString message)
        throws omero.ServerError;

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __ctx The Context map to send with the invocation.
     **/
    public String setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Like {@link #setStatus} but also sets the message.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, Ice.Callback __cb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, Callback_JobHandle_setStatusAndMessage __cb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx, Callback_JobHandle_setStatusAndMessage __cb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, 
                                                     omero.RString message, 
                                                     IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, 
                                                     omero.RString message, 
                                                     IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                                     IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, 
                                                     omero.RString message, 
                                                     java.util.Map<String, String> __ctx, 
                                                     IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, 
                                                     omero.RString message, 
                                                     java.util.Map<String, String> __ctx, 
                                                     IceInternal.Functional_GenericCallback1<String> __responseCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                                     IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                                     IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __result The asynchronous result object.
     **/
    public String end_setStatusAndMessage(Ice.AsyncResult __result)
        throws omero.ServerError;
}
